@ "Specification Test" - Part II -  Counts number of pseudotypes that   @
@ beat a subject's estimated type using Guesses and Information Search  @

load B[88,17]=c:\GG_AER_2006\SubjectsGuesses.xls;

load A[88,88]=c:\GG_AER_2006\PseudotypesLoglikelihoodsW1.jnk; 

load bts[71,6]=c:\GG_AER_2006\TyEstResAGGDGOSuNOMBestTypeW1-GIS.jnk;

@ Number of pseudotypes that beat a subject's estimated type @
nptbt=zeros(71,2);

@ List of pseudotypes that beat a subject's estimated type @
listptbt=zeros(71,88);

@ Log-likelihoods of the best 10 pseudotypes @
lbstpt=ones(71,11);
lbstpt=-1000*lbstpt;

@ Best pseudotypes - listed from 1st to 10th best @
bstpt=zeros(71,11);

ptll=zeros(88,88);

ptll=A[1:88,.];

@ Loop over subjects @
i=1;
do while i <=71;

nptbt[i,1]=10000*B[i,1];
listptbt[i,1]=10000*B[i,1];
bstpt[i,1]=10000*B[i,1];
lbstpt[i,1]=10000*B[i,1];

@ Excludes subjects #309 (42), #405 (55) @
if i/=42 and i/=55;

h=1;

j=1;
do while j<=88;

if j/=i;
if j/=42 and j/=55 and j/=83;


if ptll[i,j]>bts[i,3];  
   o=2;
   do while o <=10;
     if ptll[i,j]>lbstpt[i,o];
        pt=11;
        do while pt>o;
         lbstpt[i,pt]=lbstpt[i,pt-1];
         bstpt[i,pt]=bstpt[i,pt-1];
        pt=pt-1;
        endo;
        /* lbstpt[i,o+1]=lbstpt[i,o]; */ lbstpt[i,o]=ptll[i,j];
        /* bstpt[i,o+1]=bstpt[i,o]; */ bstpt[i,o]=j;
        o=10;
     endif;   
   o=o+1;
   endo;
   
 nptbt[i,2]=nptbt[i,2]+1;
 h=h+1; listptbt[i,h]=j; 
endif;

endif;
endif;

j=j+1;
endo;

endif;

i=i+1;
endo;

@ Counting the number of type estimates each pseudotype beats @

i=1;
do while i <=71;
 if i/=42 and i/=55;

 h=0;
 r=1;
 do while r<=88;
  
 r=r+1;
 endo;
  
  endif;
i=i+1;
endo;



format /m1/rd 2,0;

output file=c:\GG_AER_2006\numberofpseudotypesbeatbestypew1GIS.jnk reset;

"Number of pseudotypes that beat a subject's estimated type";
nptbt;
print;
"List of pseudotypes that beat a subject's estimated type";
listptbt;
print;
"List of 10 best pseudotypes (from subset of types better than subject's estimated type) ordered ";
bstpt;
print;
format /m1/rd 2,2;
"Log-Likelihoods of the 10 best pseudotypes ";
lbstpt;

output off;